# The Rocket Programming Guide

Welcome to Rocket!

This is the official guide for Rocket v0.4. It is designed to serve as a
starting point to writing web applications with Rocket and Rust. The guide is
also designed to be a reference for experienced Rocket developers. This guide is
conversational in tone. For purely technical documentation with examples, see
the [API documentation](@api).

The guide is split into several sections, each with a focus on a different
aspect of Rocket. The sections are:

   - **[Introduction](introduction/):** introduces Rocket and its philosophy.
   - **[Quickstart](quickstart/):** presents the minimal steps necessary to
      run your first Rocket application.
   - **[Getting Started](getting-started/):** a gentle introduction to getting
     your first Rocket application running.
   - **[Overview](overview/):** describes the core concepts of Rocket.
   - **[Requests](requests/):** discusses handling requests: control-flow,
     parsing, and validating.
   - **[Responses](responses/):** discusses generating responses.
   - **[State](state/):** how to manage state in a Rocket application.
   - **[Fairings](fairings/):** provides an overview of Rocket's structured
     middleware.
   - **[Testing](testing/):** how to unit and integration test a Rocket
     application.
   - **[Configuration](configuration/):** how to configure a Rocket application.
   - **[Pastebin](pastebin/):** a tutorial on how to create a pastebin with
     Rocket.
   - **[Conclusion](conclusion/):** concludes the guide and discusses next steps
     for learning.

## Getting Help

The official community support channels are [`#rocket:mozilla.org`] on Matrix
and the bridged [`#rocket`] IRC channel on Freenode at `chat.freenode.net`. We
recommend joining us on [Matrix via Riot]. If your prefer IRC, you can join via
the [Kiwi IRC client] or a client of your own.

[`#rocket:mozilla.org`]: https://chat.mozilla.org/#/room/#rocket:mozilla.org
[`#rocket`]: https://kiwiirc.com/client/chat.freenode.net/#rocket
[Matrix via Riot]: https://chat.mozilla.org/#/room/#rocket:mozilla.org
[Kiwi IRC Client]: https://kiwiirc.com/client/chat.freenode.net/#rocket
